 '*************************************************
' *                                                 *
' *   DDDDDD     4444    00000            HH   HH   *
' *   DD   DD   44 44   00   00           HH   HH   *
' *   DD   DD  44  44   00   00           HH   HH   *
' *   DD   DD  44  44   00   00           HHHHHHH   *
' *   DD   DD  4444444  00   00           HH   HH   *
' *   DD   DD      44   00   00   ..      HH   HH   *
' *   DDDDDD       44    00000    ..      HH   HH   *
' *                                                 *
' ***************************************************
' *   Version     *
' *************************************************

'
' * Dialog/4x driver function codes
'

Global Const F_SPARMS = 2             ' Set global parameters.
Global Const F_CHSTOP = 4             ' Channel stop.
Global Const F_CHSTAT = 5             ' Get channel status block.
Global Const F_SETH = 6               ' Set hook switch.
Global Const F_SETCST = 7             ' Set CST mask.
Global Const F_CLRDT = 8              ' Clear dtmf buffer.
Global Const F_GETDT = 9              ' Get dtmf digit.
Global Const F_RECB = 10              ' Record to buffer.
Global Const F_PLAYB = 11             ' Playback from buffer.
Global Const F_RECF = 12              ' Record to file.
Global Const F_PLAYF = 13             ' Playback from file.
Global Const F_DIAL = 14              ' Dial string.
Global Const F_GETDTS = 15            ' Get dtmf string.
Global Const F_XPLAYF = 19            ' Extended play function.
Global Const F_GETCAR = 27            ' Get the Call Analysis Results.
Global Const F_SXPARM = 28            ' Set ext'd shared ram parms funct
Global Const F_SCPARM = 29            ' Set channel parameters.
Global Const F_CALL = 30              ' Call a numbr using call analysis
Global Const F_SETD = 31              ' Set the digit control mask.
Global Const F_GETVER = 32            ' Get the current driver vers numb
Global Const F_PLAYUB = 34            ' Playback from a users envir bufr
Global Const F_RECUB = 35             ' Record to a users envir buffer.
Global Const F_GETCOM = 36            ' Get the comm area.
Global Const F_PUTCOM = 37            ' Put the comm area.
Global Const F_STPARM = 38            ' set channel parameter.
Global Const F_WINK = 39              ' perform wink command.
Global Const F_ROUTETS = 40           ' perform timeslot routing.
Global Const MAXFCN = 50              ' Max(last) Dialog\4x fcn number.

Global Const MINMFCN = 80             ' Min(first) AMX8x fcn number.
Global Const F_MSTART = 80            ' Start all AMX8x boards.
Global Const F_MOFF = 81              ' Disconnect all AMX8x switches.
Global Const F_MMK = 82               ' Connect the specified AMX8x chs.
Global Const F_MBRK = 83              ' Disconnect the specified AMX8 ch
Global Const F_MMASK = 84             ' Set AMX8x mask for a channel.
Global Const F_MSTOP = 85             ' Stop all AMX8x boards.
Global Const F_RSTART = 86            ' Start ringing an AMX8 connection
Global Const F_RSET = 87              ' Set AMX81 ring parms for a con.
Global Const MAXMFCN = 87             ' Max(last) AMX8x fcn number.

Global Const MINID = 129              ' Min AMX8x telephone station ID

'
' * Values for STATUS byte in the CSB
'
Global Const S_STOP = 0               ' Channel is stopped.
Global Const S_RECORD = 1             ' Channel is in record mode.
Global Const S_PLAY = 2               ' Channel is in playback mode.
Global Const S_GETDTS = 3             ' Channel is getting a DTMF string.
Global Const S_OFFH = 4               ' Channel is waiting for offhook.
Global Const S_DIAL = 5               ' Channel is dialing.
Global Const S_ONH = 6                ' Channel is waiting for onhook.
Global Const S_CALL = 7               ' Channel is in call analysis stat
Global Const S_PARM = 8               ' Channel parameter is being upd.
Global Const S_WINK = 9               ' Channel is waiting for wink cmpl.

'
' * HOOK STATES
'
Global Const H_OFFH = 0               ' Off hook.
Global Const H_ONH = 1                ' On hook.

'
' * Values for termination types (last_term) and event type
'
Global Const T_NOTERM = 0             ' No termination received.
Global Const T_MAXDT = 1              ' Maximum DTMF digits received.
Global Const T_TERMDT = 2             ' Terminating DTMF digit received.
Global Const T_STOP = 3               ' Rec/play/getdtmf stopped.
Global Const T_DOSERR = 4             ' Dos error.
Global Const T_MAXBYT = 5             ' Max bytes reached on play or rec
Global Const T_HFAIL = 6              ' Hardware failure.
Global Const T_TIME = 7               ' Rec/play/getdtmf timed out.
Global Const T_OFFH = 8               ' Offhook complete.
Global Const T_DIAL = 9               ' Dialing complete.
Global Const T_SIL = 10               ' Maximum silence received.
Global Const T_EOF = 11               ' Eof reached on playback.
Global Const T_LCTERM = 12            ' Terminate by drop in loop signal
Global Const T_DFULL = 13             ' Disk full.
Global Const T_ONH = 14               ' Onhook complete.
Global Const T_MDTERM = 17            ' AMX80 disconnect termination.
Global Const T_CATERM = 18            ' Call analysis termination.
Global Const T_LC = 20                ' Loop signal drop event.
Global Const T_RING = 21              ' Rings received.
Global Const T_SILOFF = 22            ' Silence off.
Global Const T_SILON = 23             ' Silence on.
Global Const T_AMXCON = 24            ' AMX8x channel connect.
Global Const T_AMXDIS = 25            ' AMX8x channel disconnect.
Global Const T_LCON = 26              ' Loop signal on event.
Global Const T_MAXRNG = 27            ' Max rings reached on AMX81 con
Global Const T_MCTERM = 28            ' Rings termiated by AMX8 connect
Global Const T_MDTMF = 29             ' Terminated by masked DTMF digit
Global Const T_IDTIME = 30            ' Interdigit delay exceeded.
Global Const T_NSIL = 31              ' Terminated by a max non-silence.
Global Const T_BUFFUL = 32            ' Termination from EMS buffer full.
Global Const T_BUFEMP = 33            ' Terminated from EMS buffer empty.
Global Const T_EMSERR = 34            ' Terminated by EMS error.
Global Const T_EMSLOW = 35            ' EMS buffer low.
Global Const T_EMSHI = 36             ' EMS buffer high.
Global Const T_STPARM = 37            ' parameter updated.
Global Const T_WINK = 38              ' wink protocol complete.
Global Const T_WKRECV = 39            ' wink received.
Global Const T_DTMF = 40              ' DTMF digit recived.
Global Const MAXTERM = 40             ' Max(last) termination type.


'
' * Equates for error (return) codes
'
Global Const E_SUCC = 0               ' Function was successful.
Global Const E_FAILST = 1             ' Board failed self test.
Global Const E_NODT = 2               ' Dtmf buffer empty.
Global Const E_SACT = 3               ' System already active.
Global Const E_SNACT = 4              ' System not active.
Global Const E_BADDL = 5              ' D4x hardware error.
Global Const E_BADFCN = 6             ' Invalid function code requested.
Global Const E_BADINT = 7             ' Interrupt level not available.
Global Const E_BADDCB = 8             ' DCB parmameter error.
Global Const E_BADCH = 9              ' Invalid channel number.
Global Const E_MTACT = 10             ' Multitasking func already active
Global Const E_MTNACT = 11            ' Multitasking function not active.
Global Const E_BADPAR = 12            ' Bad parameter.
Global Const E_BADVER = 13            ' Incorrect version of microcode.
Global Const E_NOTIMP = 14            ' Function not implemented/avail
Global Const E_NOTERM = 15            ' Terminating cond. not specified
Global Const E_NOMEM = 16             ' Insufficent buffer mem available.
Global Const E_DOSERR = 24            ' DOS error (DOS error code in al)
Global Const E_DSKCNT = 25            ' Error in data read/wrote to disk
Global Const E_NOAMX = 26             ' No AMX8x boards present.
Global Const E_AMXON = 27             ' AMX 8xs already started.
Global Const E_AMXOFF = 28            ' AMX 8xs already stopped.
Global Const E_BADXY = 29             ' Invalid X,Y coordinate.
Global Const E_BADPRT = 30            ' Bad AMX8x tel. station ID specified
Global Const E_BADCUR = 31            ' Bad cursor position specified.
Global Const E_EMSSW = 32             ' EMM not installed or corrupted.
Global Const E_EMSERR = 33            ' EMM reported error.
Global Const E_NOVBUF = 34            ' No buffer alloc for EMS ram disk
Global Const E_TSBADSLOT = 35         ' bad timeslot number
Global Const E_TIMEOUT = 36           ' timer expired
Global Const E_BADPROD = 37           ' not supported by this product

'
' * Equates for cst_mask
'
Global Const C_LC = &H1               ' Loop signal drop.
Global Const C_RING = &H2             ' Rings received.
Global Const C_SILOFF = &H4           ' Silence off.
Global Const C_SILON = &H8            ' Silence on.
Global Const C_OFFH = &H10            ' Offhook complete.
Global Const C_ONH = &H20             ' Onhook complete.
Global Const C_LCON = &H40            ' Loop signal on.
Global Const C_WKRECV = &H80          ' Recv incoming wink.

'
' * Equates for set parameter function
'
Global Const CH_WKDLY = &H204         ' delay before sending wink
Global Const CH_WKOUT = &H205         ' duration of outgoing wink
Global Const CH_WKMIN = &H206         ' min on for wink detection
Global Const CH_WKMAX = &H207         ' max on for wink detection

Global Const RATE_PLAY = &HE01        ' parm id for playback sampling rate
Global Const RATE_REC = &HE02         ' parm id for record sampling rate
			      
Global Const SR_6K = 6000             ' parm value for 6KHz
Global Const SR_8K = 8000             ' parm value for 8KHz

'
' * Equates for digit_ctl_mask
'
Global Const D_DTMF = 1               ' DTMF digit detection enable.
Global Const D_LPD = 2                ' Loop pulse digit detect enabled
Global Const D_DPDZ = 8               ' Dial pulse detection with zero training
Global Const D_DPD = 16               ' Dial pulse detection without zero training

'
' * Equates for digit_ctl_type
'
Global Const DT_FLUSH = 1             ' Flush dtmf digit buffer
Global Const DT_QUEUE = 2             ' put dtmf digits onto event queue


'
' * Equates for channel error conditions
'
Global Const X_NOERR = 0              ' No error.
Global Const X_BUFERR = 1             ' Error occurred.


'
' * Record mode types  (bit mapped)
'
Global Const RM_NORM = 0              ' Normal record.
Global Const RM_SCOMP = 1             ' Compress sil. from incoming data
Global Const RM_RDISK = 4             ' I/O from an EMS ram disk
Global Const RM_ADPCM = 0             ' ADPCM encoding
Global Const RM_PCM = &H100           ' Mu Law PCM mode
Global Const RM_SR6 = 0               ' 6KHz sampling rate
Global Const RM_SR8 = &H200           ' 8KHz sampling rate
Global Const RM_NOAGC = &H400         ' turn off AGC


'
' * Play mode types    (bit mapped)
'
Global Const PM_NORM = 0              ' Normal playback
Global Const PM_NDX = 1               ' Indexed playback
Global Const PM_RDISK = 4             ' I/O from an EMS ram disk
Global Const PM_FILES = 8             ' Multiple file handles for index play
Global Const PM_ADPCM = 0             ' ADPCM encoding
Global Const PM_PCM = &H100           ' Mu Law PCM mode
Global Const PM_SR6 = 0               ' 6KHz sampling rate
Global Const PM_SR8 = &H200           ' 8KHz sampling rate

'
' * Bit mask for rwb_flags in RWB
'
Global Const RW_DINIT = 1             ' Touch tone initiation on/off.
Global Const RW_TONE = 2              ' Tone before rec/playback on/off.
Global Const RW_DELAY = 4             ' Inter-digit delay starts on first digit


'
' * Bit mask for AMX8x event mask
'
Global Const A_CON = 1                ' AMX8x connect (pickup).
Global Const A_DIS = 2                ' AMX8x disconnect (hangup).


'
' * Bit mask for line status register
'
Global Const LS_CARNG = &H4           ' Call analysis detecting ring.
Global Const LS_HOOK = &H8            ' Hook status bit
Global Const LS_RING = &H10           ' Ring current bit.
Global Const LS_LOOP = &H20           ' Loop current bit.
Global Const LS_TT = &H40             ' Touch tone is waiting to be read.
Global Const LS_SIL = &H80            ' Silence bit.


'
' * Call analysis termination data types/call status values
'
Global Const CA_BUSY = 7              ' Called line is busy.
Global Const CA_NOAN = 8              ' Called line did not answer.
Global Const CA_NORNG = 9             ' Called line did not ring.
Global Const CA_CONN = 10             ' Called line connected.
Global Const CA_OPINT = 11            ' Called line recvd oper intercept


'
' * Masked DTMF termination/initiation equates
'
Global Const DM_D = &H1               ' Mask for DTMF d.
Global Const DM_1 = &H2               ' Mask for DTMF 1.
Global Const DM_2 = &H4               ' Mask for DTMF 2.
Global Const DM_3 = &H8               ' Mask for DTMF 3.
Global Const DM_4 = &H10              ' Mask for DTMF 4.
Global Const DM_5 = &H20              ' Mask for DTMF 5.
Global Const DM_6 = &H40              ' Mask for DTMF 6.
Global Const DM_7 = &H80              ' Mask for DTMF 7.
Global Const DM_8 = &H100             ' Mask for DTMF 8.
Global Const DM_9 = &H200             ' Mask for DTMF 9.
Global Const DM_0 = &H400             ' Mask for DTMF 0.
Global Const DM_S = &H800             ' Mask for DTMF *.
Global Const DM_P = &H1000            ' Mask for DTMF #.
Global Const DM_A = &H2000            ' Mask for DTMF a.
Global Const DM_B = &H4000            ' Mask for DTMF b.
Global Const DM_C = &H8000            ' Mask for DTMF c.


'
' * Channel Parameter Block structure
'
Global Const CPB_SIZE = 128           ' Size of CPB in bytes.

Type CPB
 dtpl_dly          As String * 1' Playback DTMF delay in 10ms intervals.
 dt_edge           As String * 1' DTMF message edge select.
 dtrc_dly          As Integer   ' Record DTMF delay in 10ms intervals.
 sb_siz            As Integer   ' Silence buffer size for this channel.
 nbrdna            As String * 1' # of rings before no answer.
 stdely            As Integer   ' Delay after dialing before analysis.
 cnosig            As Integer   ' Duration of no signal time out delay.
 lcdly             As Integer   ' Delay after dial before lc drop connect
 lcdly1            As Integer   ' Delay after lc drop con. before msg.
 hedge             As String * 1' Edge of answer to send connect message.
 cnosil            As Integer   ' Initial continuous noise timeout delay.
 lo1tola           As String * 1' % acceptable pos. dev of short low sig.
 lo1tolb           As String * 1' % acceptable neg. dev of short low sig.
 lo2tola           As String * 1' % acceptable pos. dev of long low sig.
 lo2tolb           As String * 1' % acceptable neg. dev of long low sig.
 hi1tola           As String * 1' % acceptable pos. dev of high signal.
 hi1tolb           As String * 1' % acceptable neg. dev of high signal.
 lo1bmax           As Integer   ' Maximum interval for shrt low for busy.
 lo2bmax           As Integer   ' Maximum interval for long low for busy.
 hi1bmax           As Integer   ' Maximum interval for 1st high for busy
 nsbusy            As String * 1' Num. of highs after nbrdna busy check.
 logltch           As Integer   ' Silence deglitch duration.
 higltch           As Integer   ' Non-silence deglitch duration.
 lo1rmax           As Integer   ' Max. short low  dur. of double ring.
 lo2rmin           As Integer   ' Min. long low  dur. of double ring.
 intflg            As String * 1' Operator intercept mode.
 intfltr           As String * 1' Minimum signal to qualify freq. detect.
 cpbrfu1           As String * 14' Reserved for future use.
 spdeb             As Integer   ' Trailing edge silence ptr debounce.
 hisiz             As Integer   ' Used to determine which lowmax to use.
 alowmax           As Integer   ' Max. low before con. if high >hisize.
 blowmax           As Integer   ' Max. low before con. if high <hisize.
 nbrbeg            As String * 1' Number of rings before analysis begins.
 hi1ceil           As Integer   ' Maximum 2nd high dur. for a retrain.
 lo1ceil           As Integer   ' Maximum 1st low dur. for a retrain.
 lowerfrq          As Integer   ' Lower allowable frequency in hz.
 upperfrq          As Integer   ' Upper allowable frequency in hz.
 timefrq           As String * 1' Total duration of good signal required.
 rejctfrq          As String * 1' Allowable % of bad signal.
 maxansr           As Integer   ' Maximum duration of answer.
 ansrdgl           As Integer   ' Silence deglitching value for answer.
 pvdmxper          As String * 1' Percent of maximum sum
 pvdszwnd          As Integer   ' Length of window in 10ms
 pvddly            As Integer   ' Delay time before starting PVD for each nonsilence in 10ms
 mxtimefrq         As Integer   ' /* Max. time for first frequency to remain in bound */
 lower2frq         As Integer   '/* Lower bound for second frequency       */
 upper2frq         As Integer   '/* Upper bound for second frequency       */
 time2frq          As Integer   '/* Min. time for second frequency to remain in bound */
 mxtime2frq        As Integer   '/* Max. time for second frequency to remain in bound */
 lower3frq         As Integer   '/* Lower bound for third frequency        */
 upper3frq         As Integer   '/* Upper bound for third frequency        */
 time3frq          As Integer   '/* Min. time for third frequency to remain in bound */
 mxtime3frq        As Integer   '/* Max. time for third frequency to remain in bound */
 cpbrfu                    As String * 27       '  /* Reserved for future use                */
End Type

'
' * DIALOG/4x Control Block data structure
'
Global Const DCB_SIZE = 128           ' Size of DCB.

Type DCB
 flashchr          As String * 1' Flash char in dialing string.
 flashtm           As Integer   ' Flash time 10ms units.
 pausetm           As Integer   ' Pause time 10ms units.
 digrate           As Integer   ' Digitizing rate in hz.
 sch_tm            As Integer   ' Maximum time slice given to scheduler.
 p_bk              As Integer   ' Pulse break interval in 10ms units.
 p_mk              As Integer   ' Pulse make interval in 10ms units.
 p_idd             As Integer   ' Pulse dial inter-digit delay in 10ms.
 t_idd             As Integer   ' Tone dial inter-digit delay in 10ms.
 oh_dly            As Integer   ' Offhook delay interval in 10 ms.
 r_on              As Integer   ' Min. ring on interval in 100ms units.
 r_off             As Integer   ' Min. ring off interval in 100ms units.
 r_ird             As Integer   ' Delay after ring cnt is reset in 100ms.
 s_bnc             As Integer   ' Sil. message debounce interval in 10ms.
 dcbrfu1           As Integer   ' Reserved for future use.
 ttdata            As String * 1' Duration of DTMF digit in 10ms units.
 minpdon           As String * 1' Min. dur. for lc on for a valid pulse.
 minpdoff          As String * 1' Min. dur. for lc off for a valid pulse.
 minipd            As Integer   ' Min. interpulse digit time for lc on.
 minlcoff          As Integer   ' Min. dur. of lc off for CST_CUR_ON.
 dcbrfu2           As String * 4' Reserved for future use.
 dcbrfu3           As String * 1' Reserevd for future use.
 maxpdoff          As Integer   ' Max. dur. for pd make.
 dcbrfu            As String * 85' Reserved for future use.
End Type


'
' * Channel status block data structure
'

Global Const CSB_SIZE = 32            ' Size of CSB.

Type CSB
 cstmask           As Integer   ' Call status interupt mask.
 status            As String * 1' Current channel status.
 cherr             As String * 1' Set if buffer under/overflow detected.
 mtfcn             As String * 1' Multitasking function in progress.
 lastterm          As Integer   ' Last termination event.
 bufcnth           As Integer   ' High order data transfer count.
 bufcnt            As Integer   ' Low order data transfer count.
 dtmfrcvd          As String * 1' Number of DTMFs in ch.'s DTMF buffer.
 doserr            As Integer   ' Last DOS error.
 linestat          As String * 1' Current line status.
 callstat          As Integer   ' Call Analysis termination type
 intrfreq          As Integer   ' Intercept frequency in 20 hertz.
 dig_mask          As String * 1' Digit control mask.
 csbrfu1           As String * 1' Reserved for future use.
 csbrfu2           As Integer   ' Reserved for future use.
 csbrfu3           As Integer   ' Reserved for future use.
 csbrfu4           As Integer   ' Reserved for future use.
 csbrfu5           As Integer   ' Reserved for future use.
 csbrfu            As String * 3' Reserved for future use.
End Type


'
' * Read/Write block structure
'

Global Const RWB_SIZE = 32            ' Size in bytes of RWB far
Global Const XRWB_SIZE = 64           ' Size in bytes of XRWB.

Type RWB
 filehndl          As Integer   ' Open DOS handle for file transfer.
 xferoff           As Integer   ' Transfer buffer address offset.
 xferseg           As Integer   ' Transfer buffer address segment.
 maxbyteh          As Integer   ' High order max # of bytes to xfer.
 maxbyte           As Integer   ' Low order max # of bytes to xfer.
 maxsec            As Integer   ' Max # of secs before timeout term.
 maxdtmf           As String * 1' Max # of DTMF digits to cause term.
 termdtmf          As String * 1' DTMF digit which will cause term.
 maxsil            As String * 1' Seconds of silence to cause term.
 loopsig           As String * 1' Terminate on drop in loop current.
 indexoff          As Integer   ' Index table address offset.
 indexseg          As Integer   ' Index table address segment.
 rwbflags          As String * 1' Record/Playback initiation bits.
 rwbdata1          As String * 1' Initiation tone duration (bits 0-3).
 amxterm           As String * 1' Terminating AMX telephone station ID.
 curpos            As Integer   ' Low order cursor position.
 curposh           As Integer   ' High order cursor position.
 isxrwb            As String * 1' Extended RWB flag.
 rwbrfu2           As String * 4' Reserved for future use.

'
' * Extended RWB fields
'
 xrwbrfu1          As Integer   ' Reserved for future use.
 dtinit            As Integer   ' DTMF function initiator set.
 dtterm            As Integer   ' DTMF function terminator set.
 intrdig           As String * 1' Maximum interdigit delay in secs.
 maxnsil           As String * 1' Max # of secs of non-sil to cause term
 emsthrsh          As Integer   ' min byte count before warning
 xrwbrfu           As String * 50' Reserved for future use
End Type


'
' * Call analysis results structure
'
Global Const CAR_SIZE = 32            ' Size of the structure.

Type CAR
 termtype          As String * 1' Last call progress term. for this ch.
 frqout            As String * 1' Percent of frequency out of bounds.
 frqherz           As Integer   ' Frequency detected in hertz.
 sizehigh          As Integer   ' Dur. of non-silent period. 10ms units.
 shortlow          As Integer   ' Dur. of shorter silent period.
 longlow           As Integer   ' Duration of longer silent period.
 ansrsize          As Integer   ' Duration of answer in 10ms units.
 conntype          As String * 1' Connection type.
 carrfu            As String * 19' Reserved for future use.
End Type

'
' * Application to Device Driver Communication Area
'

Global Const ADCCB_SIZE = 32

Type ADCCB
 a_d_bct           As Long
 a_d_rfu           As String * 28
End Type


'
' * Device Driver to Application Communication Area
'
Global Const DACCB_SIZE = 32

Type DACCB
 d_a_bct           As Long
 d_a_rfu           As String * 28
End Type


'
' * IDDS system function codes
'
Global Const MIDDSFN = &H70           ' Min(first) IDDS function
Global Const F_DEVSRV = &H70          ' Device level services
Global Const F_EXESRV = &H71          ' Executive level services
Global Const F_DEVCOM = &H75          ' Application level services
Global Const MXIDDSFN = &H75          ' Max(last) IDDS function

'
' * Service function Executive level services function codes
'
Global Const MSEXESFN = &H0           ' Min(first) IDDS function
Global Const FI_APSCH = &H0           ' inform appl of scheduler entry
Global Const FI_APACT = &H1           ' inform appl of scheduler activity
Global Const FI_APEVT = &H2           ' inform appl of event queue entry
Global Const MXEXESFN = &H2           ' Max(last) IDDS function

'
' * Service function Device level services function codes
'
Global Const MSDEVSFN = &H0           ' min (first) IDDS function
Global Const FI_REGDRV = &H0          ' register driver
Global Const FI_SIZEQ = &H1           ' get the memory requirements of a Q
Global Const FI_OPENQ = &H2           ' request to open a Q
Global Const FI_PUTQ = &H3            ' enqueue a message
Global Const FI_GETQ = &H4            ' get a message off a Q
Global Const FI_EMPTYQ = &H5          ' empty a queue
Global Const FI_FLUSHQ = &H6          ' flush 1 entry from the queue
Global Const FI_SCANQ = &H7           ' Scan the queue for a value
Global Const FI_GETLVL = &H8          ' get the h/w interrupt level
Global Const FI_PUTLVL = &H9          ' store the hardware intr level
Global Const FI_INSINT = &HA          ' install drivers interrupt hndlr
Global Const FI_UININT = &HB          ' de-install drivers h/w intr hndlr
Global Const FI_GETIV = &HC           ' get the interrupt vector
Global Const FI_PUTIV = &HD           ' install this interrupt vector
Global Const FI_GETMSG = &HE          ' get vector to the intr msg hdlr
Global Const FI_PUTMSG = &HF          ' install h/w intr msg hdlr
Global Const FI_PUT55 = &H10          ' install a 55ms timer
Global Const FI_DIS55 = &H11          ' deinstall a 55ms timer
Global Const FI_ISDRV = &H12          ' determine if a driver is installed
Global Const FI_SCHED = &H13          ' call the scheduler
Global Const FI_PAUSE = &H14          ' wait for a real time interval
Global Const FI_UREG = &H15           ' unregister a device
Global Const FI_GETREV = &H16         ' get idds revision
Global Const FI_USREVT = &H17         ' put urer event onto event queue
Global Const FI_BEEP = &H18           ' beep the speaker on error condition
Global Const MXDEVSFN = &H18          ' Max (last) IDDS function


'
' *------- IDDS error return codes
'
Global Const EI_SUCC = 0              ' Function was successful
Global Const EI_REGERR = 113          ' driver registration error
Global Const EI_BADHND = 114          ' Bad handle
Global Const EI_BADDEV = 115          ' Bad device type specified
Global Const EI_MAXQS = 116           ' Maximum number of queues
Global Const EI_BADQT = 117           ' Queue type error
Global Const EI_QFULL = 118           ' Queue full
Global Const EI_QMPTY = 119           ' Queue empty
Global Const EI_BADFCN = 120          ' bad function
Global Const EI_BADPAR = 121          ' bad parmeter
Global Const EI_VECUSD = 122          ' vector already in use
Global Const EI_NOIMP = 123           ' function not implemented


'
' *------- Defined Device Types
'
Global Const DV_IDDS = 1              ' IDDS device type
Global Const DV_D40 = 2               ' D40 driver type

'
' *------- User definable devices
'
Global Const DV_USER1 = &HF0            ' User defined device 1
Global Const DV_USER2 = &HF1            ' User defined device 2
Global Const DV_USER3 = &HF2            ' User defined device 3
Global Const DV_USER4 = &HF3            ' User defined device 4
Global Const DV_USER5 = &HF4            ' User defined device 5
Global Const DV_USER6 = &HF5            ' User defined device 6
Global Const DV_USER7 = &HF6            ' User defined device 7
Global Const DV_USER8 = &HF7            ' User defined device 8


'
' *------- Defined Q Types
'
Global Const Q_NRML = 0                 ' non-prioriorized FIFO Q
Global Const Q_NPSLL = 1                ' non-priority FIFO Single Linked List

'
' *------- miscellaneous
'
Global Const Q_STDREQ = 0             ' Standard request queue handle
Global Const Q_STDEVT = 1             ' Standard event queue handle

'/*
' * GLOBAL TONE DETECTION
' */

'/*
' * Masks for functions dl_enbtone() and dl_distone()
' */
Global Const TONE_ON = 1            '/* Enables/disables Tone On messages  */
Global Const TONE_OFF = 2           '/* Enables/disables Tone Off messages */

Global Const TONE_ALL = &HFFFF      '/* Enables/disables ALL tone messages */

'/*
' * Tone detection modes
' */
Global Const TN_LEADING = &H100      '/* Leading edge detection  */
Global Const TN_TRAILING = &H200     '/* Trailing edge detection */

'/*
' * Miscellaneous GTD items
' */
Global Const TN_DIGTYPE = 5         '/* Reserved digit type for user */



'/*
' * GENERAL TONE GENERATION
' */

'/*
' * Tone generation template
' */
Type TN_GEN
	  tg_dflag As Integer ';     /* Dual Tone - 1, Single Tone - 0    */
	  tg_freq1 As Integer ';     /* Frequency for tone 1 (Hz)         */
	  tg_freq2 As Integer ';     /* Frequency for tone 2 (Hz)         */
	  tg_ampl1 As Integer ';     /* Amplitude for tone 1 (dB)         */
	  tg_ampl2 As Integer ';     /* Amplitude for tone 2 (dB)         */
	  tg_dur As Integer ';       /* Duration of generated tone (10ms) */
End Type

'/*
' * For use with tg_dflag parameter in TN_GEN
' */
Global Const TN_SINGLE = 0         '/* Indicates single tone */
Global Const TN_DUAL = 1            '/* Indicates dual tone   */


 '/*************************************************************************
 '*
 '* Speed/Volume Adjustment Condition Block(SVCB)
 '*
 '**************************************************************************/

Type SVCB
   adjtype As Integer ';    /* Type of adjustment                      */
   adjsize As Integer '; /* Adjustment size                         */
   Digit As String * 1';   /* ASCII digit that causes play adjustment */
   digtype As String * 1'; /* Digit type                              */
End Type

' /*************************************************************************
' *
' * Speed/Volume Modification Table(SVMT)
' *
' **************************************************************************/

Type SVMT
   decrease As String * 10 '  /*        */
   origin As String * 1    '     /* Origin */
   Increase As String * 10      '     /*        */
End Type


'/*
' * Speed and Volume(S/V) Control
' */
Global Const SV_SPEEDTBL = &H1        '/* Modify speed */
Global Const SV_VOLUMETBL = &H2       '/* Modify volume */
				      
Global Const SV_ABSPOS = &H0          '/* Absolute position */
Global Const SV_RELCURPOS = &H10      '/* Relative position from current position */
Global Const SV_TOGGLE = &H20         '/* Toggle */
		       
Global Const SV_WRAPMOD = &H10        '/* S/V Modification Table wraparound enable */
Global Const SV_SETDEFAULT = &H20     '/* Reset to default S/V Modification Table */
Global Const SV_LEVEL = &H100         '/* Digit level sensitive */
Global Const SV_BEGINPLAY = &H200     '/* Apply play adjustment at beginning of each playback */

'/*
' * S/V toggle modes for Play Adjustment Conditions
' */
Global Const SV_TOGORIGIN = &H0       '/* Toggle between origin and last modified position */
Global Const SV_CURORIGIN = &H1       '/* Reset current position to the origin */
Global Const SV_CURLASTMOD = &H2      '/* Reset current position to last modified position */
Global Const SV_RESETORIG = &H3       '/* Reset current position and last modified state to origin */

'/*
' * S/V defines for dl_addspddig()
' */
Global Const SV_ADD10PCT = 1         '/* Speed up playback 10 percent     */
Global Const SV_ADD20PCT = 2         '/* Speed up playback 20 percent     */
Global Const SV_ADD30PCT = 3         '/* Speed up playback 30 percent     */
Global Const SV_ADD40PCT = 4         '/* Speed up playback 40 percent     */
Global Const SV_ADD50PCT = 5         '/* Speed up playback 50 percent     */
Global Const SV_SUB10PCT = -1        '/* Slow down playback 10 percent    */
Global Const SV_SUB20PCT = -2        '/* Slow down playback 20 percent    */
Global Const SV_SUB30PCT = -3        '/* Slow down playback 30 percent    */
Global Const SV_SUB40PCT = -4        '/* Slow down playback 40 percent    */
Global Const SV_SUB50PCT = -5        '/* Slow down playback 50 percent    */
Global Const SV_NORMAL = &HFF        ' /* Set playback to normal speed/vol */
				     
'/*
' * S/V defines for dl_addvoldig()
' */
Global Const SV_ADD2DB = 1           '/* Increase volume of playback 2dB */
Global Const SV_ADD4DB = 2           '/* Increase volume of playback 4dB */
Global Const SV_ADD6DB = 3           '/* Increase volume of playback 6dB */
Global Const SV_ADD8DB = 4           '/* Increase volume of playback 8dB */
Global Const SV_SUB2DB = -1          '/* Decrease volume of playback 2dB */
Global Const SV_SUB4DB = -2          '/* Decrease volume of playback 4dB */
Global Const SV_SUB6DB = -3          '/* Decrease volume of playback 6dB */
Global Const SV_SUB8DB = -4          '/* Decrease volume of playback 8dB */
				     '

'
' * function prototypes
'
Declare Sub clrrwb Lib "VBV_DLGC.DLL" (mRWB As RWB)
Declare Sub clrxrwb Lib "VBV_DLGC.DLL" (mRWB As RWB)
Declare Sub clrdcb Lib "VBV_DLGC.DLL" (mDCB As DCB)
Declare Sub clrcpb Lib "VBV_DLGC.DLL" (mCPB As CPB)
Declare Function setcparm Lib "VBV_DLGC.DLL" (ByVal ch As Integer, mCPB As CPB) As Integer
Declare Function stopch Lib "VBV_DLGC.DLL" (ByVal ch As Integer) As Integer
Declare Function getcstat Lib "VBV_DLGC.DLL" (ByVal ch As Integer, mCSB As CSB) As Integer
Declare Function sethook Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal onoff As Integer) As Integer
Declare Function setcst Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal mask As Integer, ByVal numrings As Integer) As Integer
Declare Function clrdtmf Lib "VBV_DLGC.DLL" (ByVal ch As Integer) As Integer
Declare Function readdtmf Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal dtmf As String) As Integer
Declare Function recfile Lib "VBV_DLGC.DLL" (ByVal ch As Integer, mRWB As RWB, ByVal Prm3 As Integer) As Integer
Declare Function xplayf Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, mRWB As RWB) As Integer
Declare Function dial Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal dialstr As String) As Integer
Declare Function callp Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal dialstr As String) As Integer
Declare Function getdtmfs Lib "VBV_DLGC.DLL" (ByVal ch As Integer, Prm2 As RWB) As Integer
Declare Function setdmask Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal mask As Integer, ByVal Prm3 As Integer) As Integer
Declare Function getver Lib "VBV_DLGC.DLL" (xx As Integer, yy As Integer) As Integer
Declare Function getcom Lib "VBV_DLGC.DLL" (ByVal ch As Integer, mDACCB As DACCB) As Integer
Declare Function putcom Lib "VBV_DLGC.DLL" (ByVal ch As Integer, mADCCB As ADCCB) As Integer
Declare Function playuser Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As String, Prm3 As Integer) As Integer
Declare Function recuser Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As String, Prm3 As Integer) As Integer
Declare Function getcar Lib "VBV_DLGC.DLL" (ByVal ch As Integer, mCAR As CAR) As Integer
Declare Function sw_on Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer) As Integer
Declare Function sw_off Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer) As Integer
Declare Function amx_off Lib "VBV_DLGC.DLL" () As Integer
Declare Function amx_msk Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer) As Integer
Declare Function ring Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer) As Integer
Declare Function set_ring Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer) As Integer
Declare Function putevt Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer
Declare Function setiparm Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer
Declare Function wink Lib "VBV_DLGC.DLL" (ByVal ch As Integer) As Integer
Declare Function sb_route Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer) As Integer
Declare Function sb_rtrcvxmt Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer


Type IDCB
 version           As Integer   ' firmware revision
 segment           As Integer   ' segment address
 type              As String * 1' board type
 int_lvl           As String * 1' hardware interrupt level
 bufsize           As Integer   ' size of buffer
 numchan           As String * 1' number of channels
 basechn           As String * 1' base channel - 1
 config            As String * 1' copy of dl_syscfg from d40
 product           As String * 1' copy of dl_product, A/B info
 rfu               As String * 20' 20 chars
End Type

Declare Function calld40 Lib "VBV_DLGC.DLL" (ByVal Prm1 As String, ByVal Prm2 As String, Prm3 As Integer, Prm4 As Integer, Prm5 As Integer) As Integer

'important note for calld40x: parameter ptr must be a real mode segment/offset! (use GlobalDosAlloc/GlobalDosFree)
Declare Function calld40x Lib "VBV_DLGC.DLL" (ByVal Prm1 As String, ByVal Prm2 As String, Prm3 As Integer, Prm4 As Integer, ptr As Any) As Integer

'note this function must not be called before vbv_start_system ! (or it will fail)
Declare Function startamx Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, Prm2 As Integer) As Integer
Declare Function stopamx Lib "VBV_DLGC.DLL" () As Integer


Declare Function dl_addtone Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer
Declare Function dl_deltones Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer) As Integer
Declare Function dl_enbtone Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer
Declare Function dl_distone Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer
Declare Function dl_blddt Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer, ByVal Prm5 As Integer, ByVal Prm6 As Integer) As Integer
Declare Function dl_blddtcad Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer, ByVal Prm5 As Integer, ByVal Prm6 As Integer, ByVal Prm7 As Integer, ByVal Prm8 As Integer, ByVal Prm9 As Integer) As Integer
Declare Function dl_bldst Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer) As Integer
Declare Function dl_bldstcad Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer, ByVal Prm5 As Integer, ByVal Prm6 As Integer, ByVal Prm7 As Integer, ByVal Prm8 As Integer) As Integer
Declare Function buildtone Lib "VBV_DLGC.DLL" (ByVal Prm1 As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer, ByVal Prm5 As Integer, ByVal Prm6 As Integer, ByVal Prm7 As Integer, ByVal Prm8 As Integer, ByVal Prm9 As Integer, ByVal Prm10 As Integer, ByVal Prm11 As Integer, ByVal Prm12 As Integer) As Integer
Declare Function dl_playtone Lib "VBV_DLGC.DLL" (ByVal ch As Integer, RWB As RWB) As Integer
Declare Sub dl_bldtngen Lib "VBV_DLGC.DLL" (TN_GEN As TN_GEN, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer, ByVal Prm5 As Integer, ByVal Prm6 As Integer)
Declare Function dl_adjsv Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer, ByVal Prm4 As Integer)
Declare Function dl_setsvcond Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, Prm3 As SVCB) As Integer
Declare Function dl_clrsvcond Lib "VBV_DLGC.DLL" (ByVal ch As Integer)
Declare Function dl_getcursv Lib "VBV_DLGC.DLL" (ByVal ch As Integer, Prm2 As Integer, Prm3 As Integer) As Integer
Declare Function dl_setsvmt Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, Prm3 As SVMT, ByVal Prm4 As Integer) As Integer
Declare Function dl_getsvmt Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, Prm3 As SVMT) As Integer
Declare Function dl_addspddig Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer
Declare Function dl_addvoldig Lib "VBV_DLGC.DLL" (ByVal ch As Integer, ByVal Prm2 As Integer, ByVal Prm3 As Integer) As Integer

